SystemOrganization addCategory: #ConfigurationOfXenon!

Object subclass: #ConfigurationOfXenon
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfXenon'!

!ConfigurationOfXenon class methodsFor: 'development support' stamp: 'BernardoContreras 2/26/2012 23:04'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfXenon class methodsFor: 'private' stamp: 'BernardoContreras 2/26/2012 23:04'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfXenon class methodsFor: 'private' stamp: 'BernardoContreras 2/26/2012 23:04'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfXenon class methodsFor: 'private' stamp: 'BernardoContreras 2/26/2012 23:04'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfXenon class methodsFor: 'metacello tool support' stamp: 'BernardoContreras 2/26/2012 23:04'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfXenon class methodsFor: 'loading' stamp: 'BernardoContreras 2/26/2012 23:04'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfXenon class methodsFor: 'loading' stamp: 'BernardoContreras 2/26/2012 23:04'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfXenon class methodsFor: 'loading' stamp: 'BernardoContreras 2/26/2012 23:04'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfXenon class methodsFor: 'accessing' stamp: 'BernardoContreras 2/26/2012 23:04'!
project

	^self new project! !

!ConfigurationOfXenon class methodsFor: 'development support' stamp: 'BernardoContreras 2/26/2012 23:04'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfXenon methodsFor: 'baselines' stamp: 'BernardoContreras 4/15/2012 01:41'!
baseline01: spec
	<version: '0.1-baseline'>
	spec
		for: #'pharo'
		do: [ 
			spec blessing: #baseline.
			spec repository: 'http://ss3.gemstone.com/ss/crappy-code'.
			spec package: 'AST-Core' with: [ spec repository: 'http://www.squeaksource.com/rb' ];
				package: 'Xenon-Core' with: [ spec requires: #('AST-Core') ];
				package: 'Xenon-Tests' with: [ spec requires: #('Xenon-Core') ].
			spec
				group: 'default' with: #('Xenon-Core' 'Xenon-Tests');
				group: 'Core' with: #('Xenon-Core');
				group: 'Tests' with: #('Xenon-Tests') ]! !

!ConfigurationOfXenon methodsFor: 'symbolic versions' stamp: 'BernardoContreras 4/9/2012 21:41'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'pharo' version: '0.1'.
! !

!ConfigurationOfXenon methodsFor: 'accessing' stamp: 'BernardoContreras 2/26/2012 23:04'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfXenon methodsFor: 'versions' stamp: 'BernardoContreras 4/15/2012 01:43'!
version01: spec
	<version: '0.1' imports: #('0.1-baseline')>
	spec
		for: #'pharo'
		do: [ 
			spec blessing: #development.
			spec description: ' initial version'.
			spec author: 'BernardoContreras'.
			spec timestamp: '2/26/2012 23:06'.
			spec
				package: 'AST-Core' with: 'AST-Core-lr.92';
				package: 'Xenon-Core' with: 'Xenon-Core';
				package: 'Xenon-Tests' with: 'Xenon-Tests' ]! !
